const __vite_ssr_import_0__ = await __vite_ssr_import__("/modules/util/src/decorators.ts");
__vite_ssr_exportAll__(__vite_ssr_import_0__);
const __vite_ssr_import_1__ = await __vite_ssr_import__("/modules/util/src/html.ts");
__vite_ssr_exportAll__(__vite_ssr_import_1__);
const __vite_ssr_import_2__ = await __vite_ssr_import__("/modules/util/src/pref.ts");
__vite_ssr_exportAll__(__vite_ssr_import_2__);
const __vite_ssr_import_3__ = await __vite_ssr_import__("/modules/util/src/timeout.ts");
__vite_ssr_exportAll__(__vite_ssr_import_3__);
function hash(s) {
  let h = 0;
  for (let i = 0; i < s.length; i++) {
    h = Math.imul(31, h) + s.charCodeAt(i) | 0;
  }
  return h;
}
Object.defineProperty(__vite_ssr_exports__, "hash", { enumerable: true, configurable: true, get(){ return hash }});
function search(haystack, target, comparator, { min = 0, max = haystack.length - 1, precise = true } = {}) {
  if (haystack.length === 0)
    return null;
  let index = -1;
  while (min <= max) {
    index = min + (max - min >>> 1);
    const cmp = comparator(haystack[index], target);
    if (cmp === true || cmp === 0)
      return { element: haystack[index], index };
    if (cmp === false)
      return null;
    if (cmp < 0)
      min = index + 1;
    else if (cmp > 0)
      max = index - 1;
  }
  if (index === -1)
    return null;
  if (!precise)
    return { element: null, index };
  return null;
}
Object.defineProperty(__vite_ssr_exports__, "search", { enumerable: true, configurable: true, get(){ return search }});
function isEmpty(obj) {
  if (!obj)
    return true;
  if (obj instanceof Array)
    return obj.length === 0;
  if (obj.constructor === Object)
    return Object.keys(obj).length === 0;
  return true;
}
Object.defineProperty(__vite_ssr_exports__, "isEmpty", { enumerable: true, configurable: true, get(){ return isEmpty }});
function has(key, obj) {
  if (typeof obj !== "object")
    return false;
  return key in obj && obj[key] !== void 0;
}
Object.defineProperty(__vite_ssr_exports__, "has", { enumerable: true, configurable: true, get(){ return has }});
function removeUndefined(obj) {
  const keys = Object.keys(obj);
  for (let i = 0; i < keys.length; i++) {
    if (obj[keys[i]] === void 0)
      delete obj[keys[i]];
  }
  return obj;
}
Object.defineProperty(__vite_ssr_exports__, "removeUndefined", { enumerable: true, configurable: true, get(){ return removeUndefined }});
function escapeRegExp(str) {
  return str.replace(/[.*+?^${}()|\[\]\\]/g, "\\$&");
}
Object.defineProperty(__vite_ssr_exports__, "escapeRegExp", { enumerable: true, configurable: true, get(){ return escapeRegExp }});
function hasSigil(str, sigils) {
  if (typeof str !== "string")
    return false;
  if (typeof sigils === "string")
    return str.startsWith(sigils);
  for (const sigil of sigils)
    if (str.startsWith(sigil))
      return true;
  return false;
}
Object.defineProperty(__vite_ssr_exports__, "hasSigil", { enumerable: true, configurable: true, get(){ return hasSigil }});
function unSigil(str, sigils) {
  if (typeof sigils === "string") {
    return str.startsWith(sigils) ? str.slice(sigils.length) : str;
  } else {
    for (const sigil of sigils) {
      if (str.startsWith(sigil)) {
        return unSigil(str.slice(sigil.length), sigils);
      }
    }
  }
  return str;
}
Object.defineProperty(__vite_ssr_exports__, "unSigil", { enumerable: true, configurable: true, get(){ return unSigil }});
function createID(prefix = "") {
  const suffix = hash(Math.random() * 100 + prefix);
  return `${prefix}-${suffix}`;
}
Object.defineProperty(__vite_ssr_exports__, "createID", { enumerable: true, configurable: true, get(){ return createID }});
function toPoints(str) {
  const codes = [];
  for (let i = 0; i < str.length; i++) {
    codes.push(str.codePointAt(i));
  }
  return codes;
}
Object.defineProperty(__vite_ssr_exports__, "toPoints", { enumerable: true, configurable: true, get(){ return toPoints }});
function pointsMatch(points, str, pos) {
  if (typeof str === "string") {
    for (let i = 0; i < points.length; i++) {
      if (points[i] !== str.codePointAt(pos + i))
        return false;
    }
  } else {
    for (let i = 0; i < points.length; i++) {
      if (points[i] !== str[pos + i])
        return false;
    }
  }
  return true;
}
Object.defineProperty(__vite_ssr_exports__, "pointsMatch", { enumerable: true, configurable: true, get(){ return pointsMatch }});
function perfy(meta, threshold) {
  const start = performance.now();
  return (msg) => {
    const time = parseFloat((performance.now() - start).toFixed(4));
    if (meta && threshold && time > threshold) {
      if (msg) {
        console.log(`${msg} | ${meta}: ${time}ms`);
      } else {
        console.log(`${meta}: ${time}ms`);
      }
    }
    return time;
  };
}
Object.defineProperty(__vite_ssr_exports__, "perfy", { enumerable: true, configurable: true, get(){ return perfy }});
function sleep(ms) {
  return new Promise((resolve) => setTimeout(resolve, ms));
}
Object.defineProperty(__vite_ssr_exports__, "sleep", { enumerable: true, configurable: true, get(){ return sleep }});
function animationFrame() {
  return new Promise((resolve) => requestAnimationFrame(resolve));
}
Object.defineProperty(__vite_ssr_exports__, "animationFrame", { enumerable: true, configurable: true, get(){ return animationFrame }});
function throttle(fn, limitMS, immediate = false) {
  let timeout = null;
  let initialCall = true;
  return function(...args) {
    const callNow = immediate && initialCall;
    const next = () => {
      fn.apply(this, [...args]);
      timeout = null;
    };
    if (callNow) {
      initialCall = false;
      next();
    }
    if (!timeout)
      timeout = setTimeout(next, limitMS);
  };
}
Object.defineProperty(__vite_ssr_exports__, "throttle", { enumerable: true, configurable: true, get(){ return throttle }});
function debounce(fn, wait = 1) {
  let timeout;
  return function(...args) {
    clearTimeout(timeout);
    timeout = setTimeout(() => void fn.call(this, ...args), wait);
  };
}
Object.defineProperty(__vite_ssr_exports__, "debounce", { enumerable: true, configurable: true, get(){ return debounce }});
async function waitFor(conditionFn, asyncTimerFn = () => sleep(100)) {
  while (await conditionFn() === false) {
    await asyncTimerFn();
    continue;
  }
  return true;
}
Object.defineProperty(__vite_ssr_exports__, "waitFor", { enumerable: true, configurable: true, get(){ return waitFor }});
function createLock(fn) {
  const call = async (args) => {
    return await fn(...args);
  };
  let running = null;
  return async (...args) => {
    if (running)
      await running;
    running = call(args);
    const result = await running;
    running = null;
    return result;
  };
}
Object.defineProperty(__vite_ssr_exports__, "createLock", { enumerable: true, configurable: true, get(){ return createLock }});
function createMutatingLock(fn) {
  const call = async (args) => {
    return await fn(...args);
  };
  let running;
  let useArgs = [];
  return async (...args) => {
    useArgs = args;
    if (running)
      return null;
    running = true;
    let result = await call(args);
    while (useArgs !== args) {
      args = useArgs;
      result = await call(args);
    }
    useArgs = [];
    running = false;
    return result;
  };
}
Object.defineProperty(__vite_ssr_exports__, "createMutatingLock", { enumerable: true, configurable: true, get(){ return createMutatingLock }});
function createAnimQueued(fn) {
  let queued;
  let useArgs = [];
  return (...args) => {
    useArgs = args;
    if (queued !== true) {
      queued = true;
      requestAnimationFrame(async () => {
        await fn(...useArgs);
        queued = false;
      });
    }
  };
}
Object.defineProperty(__vite_ssr_exports__, "createAnimQueued", { enumerable: true, configurable: true, get(){ return createAnimQueued }});
const HAS_IDLE_CALLBACK = "requestIdleCallback" in globalThis;
/*! c8 ignore next */
function idleCallback(cb, timeout = 100) {
  if (!HAS_IDLE_CALLBACK) {
    return new Promise((resolve) => setTimeout(() => resolve(cb()), timeout));
  } else {
    return new Promise((resolve) => requestIdleCallback(() => resolve(cb()), { timeout }));
  }
}
Object.defineProperty(__vite_ssr_exports__, "idleCallback", { enumerable: true, configurable: true, get(){ return idleCallback }});
/*! c8 ignore next */
function createIdleQueued(fn, timeout = 100) {
  if (!HAS_IDLE_CALLBACK)
    return createAnimQueued(fn);
  let queued;
  let useArgs = [];
  return (...args) => {
    useArgs = args;
    if (queued !== true) {
      queued = true;
      requestIdleCallback(async () => {
        await fn(...useArgs);
        queued = false;
      }, { timeout });
    }
  };
}
Object.defineProperty(__vite_ssr_exports__, "createIdleQueued", { enumerable: true, configurable: true, get(){ return createIdleQueued }});
function mod(a, n) {
  return (a % n + n) % n;
}
Object.defineProperty(__vite_ssr_exports__, "mod", { enumerable: true, configurable: true, get(){ return mod }});
function replaceRange(str, from, to, sub) {
  return str.substr(0, from) + sub + str.substr(to);
}
Object.defineProperty(__vite_ssr_exports__, "replaceRange", { enumerable: true, configurable: true, get(){ return replaceRange }});
function uppercase(str, locale) {
  return locale ? str.toLocaleUpperCase(locale) : str.toUpperCase();
}
Object.defineProperty(__vite_ssr_exports__, "uppercase", { enumerable: true, configurable: true, get(){ return uppercase }});
function lowercase(str, locale) {
  return locale ? str.toLocaleLowerCase(locale) : str.toLowerCase();
}
Object.defineProperty(__vite_ssr_exports__, "lowercase", { enumerable: true, configurable: true, get(){ return lowercase }});
function titlecase(str, locale) {
  return replaceRange(lowercase(str, locale), 0, 1, uppercase(str[0], locale));
}
Object.defineProperty(__vite_ssr_exports__, "titlecase", { enumerable: true, configurable: true, get(){ return titlecase }});
function isTitlecased(str, locale) {
  return uppercase(str[0], locale) === str[0];
}
Object.defineProperty(__vite_ssr_exports__, "isTitlecased", { enumerable: true, configurable: true, get(){ return isTitlecased }});
function isUppercased(str, locale) {
  return uppercase(str, locale) === str;
}
Object.defineProperty(__vite_ssr_exports__, "isUppercased", { enumerable: true, configurable: true, get(){ return isUppercased }});
function isLowercased(str, locale) {
  return lowercase(str, locale) === str;
}
Object.defineProperty(__vite_ssr_exports__, "isLowercased", { enumerable: true, configurable: true, get(){ return isLowercased }});
async function url(imp) {
  return new URL((await imp).default, __vite_ssr_import_meta__.url).toString();
}
Object.defineProperty(__vite_ssr_exports__, "url", { enumerable: true, configurable: true, get(){ return url }});
function dedupe(arr, ...insert) {
  return [...new Set([...arr, ...insert])];
}
Object.defineProperty(__vite_ssr_exports__, "dedupe", { enumerable: true, configurable: true, get(){ return dedupe }});

